; PF 21 DEC 2001
; CONSTANTES USUELLES;

PORTA		EQU	0X05
TRISA		EQU 	0X85
PORTB		EQU	0X06
TRISB		EQU	0X86
STATUS	EQU	0X03

W		EQU	0
F		EQU	1

RP0		EQU	5
Z		EQU	2

DELAY       EQU	0X023			; USED IN DELAYXXX ROUTINES
X_DELAY     EQU	0X024 		; USED IN X_DELAYXXX ROUTINES
DUMMY25	EQU  	0X025
DUMMY26	EQU 	0X026
A_CHAR	EQU 	0X027			; FOR ONE CHARACTER
COUNT		EQU	0X028			; HOW MANY TO WRITE
COUNTER 	EQU  0X029

; MAIN PROGRAM STARTS HERE
;
MAIN		ORG 0
		MOVLW 0D255		; 255 DECIMAL
     		MOVWF	X_DELAY
	
		MOVLW	0X04		
		MOVWF	COUNT
LOOP1		
		CALL  TEMPO1S
	
		DECFSZ COUNT
		GOTO	LOOP1

		BSF PORTA,1
		MOVLW 0X08
		MOVWF COUNTER
		MOVLW 0X0F
		MOVWF DUMMY26
LOOP2
		MOVF DUMMY26,W
		XORLW 0X0F
		MOVWF DUMMY26
		MOVWF TRISB
		MOVLW 0XFF
		CALL TEMPO1S
		DECFSZ COUNTER
		GOTO LOOP2
		
		BCF PORTA,0
		BCF PORTB,0
		CALL TEMPO1S
		BCF PORTB,1
		CALL TEMPO1S
		BCF PORTB,2
		CALL TEMPO1S
		BCF PORTB,3
		CALL TEMPO1S
								
	BCF PORTA,0



STOP		GOTO 	STOP




;==========================
TEMPO1S
	MOVLW 0XFF
	MOVWF	DUMMY25
TEMP1
	CALL X_DELAY500
	DECFSZ DUMMY25
	GOTO TEMP1
TEMPO1S_END
	RETURN


;***********************************  A 500US DELAY @ 4MHZ X-TAL
DELAY500
    MOVLW       0D165              ; +1        1 CYCLE
    MOVWF       DELAY               ; +2        1 CYCLE
DELAY500_LOOP
    DECFSZ      DELAY, F            ; STEP1     1 CYCLE
    GOTO        DELAY500_LOOP       ; STEP2     2 CYCLES
DELAY500_END
    RETURN                          ; +3        2 CYCLES

;***********************************  A DELAY OF 'W' * 500MS
X_DELAY500
    MOVWF       X_DELAY             ; +1        1 CYCLE
X_DELAY500_LOOP
    CALL        DELAY500            ; STEP1     WAIT 500USEC
    DECFSZ      X_DELAY, F          ; STEP2     1 CYCLE
    GOTO        X_DELAY500_LOOP     ; STEP3     2 CYCLES
X_DELAY500_END
    RETURN                          ; +2        2 CYCLES


SOURCE=TEST.ASM

