;Attention: PB avec ICPROG si zone entre @140 et 200 laisse vierge (3FFF)
;mais  OK si initialise avec NOP
;Clean: Deleting intermediary and output files.
;Clean: Deleted file "HAPR_02.err".
;Clean: Deleted file "C:\MPLAB722\_HARP\HAPR_02.cod".
;Clean: Deleted file "C:\MPLAB722\_HARP\HAPR_02.hex".
;Clean: Deleted file "HAPR_02.lst".
;Clean: Deleted file "C:\MPLAB722\_HARP\HARP.mcs".
;Clean: Done.
;Executing: "C:\MPLAB722\MPASM Suite\MPASMWIN.EXE" /q /p16F84 "HAPR_02.asm" /l"HAPR_02.lst" /e"HAPR_02.err"
;Loaded C:\MPLAB722\_HARP\HAPR_02.COD.
;BUILD SUCCEEDED: Sun Sep 24 10:32:39 2006
;rev 1.01 25 sept
;rev 1.0 PF 23 sep 06
;version de base 1062005-v1.asm
; 16 car only 
#define misimde


        ifdef misimde 
	include	"P16F84_.INC"
	__CONFIG 0x3FF1
        else
        include "..\P16F84_.INC"
	ERRORLEVEL      -302
         __CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC
          endif

	radix	DEC	
    	EXPAND

;------- Hardware ------------
; PIC PROJECT BOARD FARNELL 527-646 avec  resonateur ceramique 4Mhz
; 8 Sorties sur PORTB -> ULN2803 -> 8x 390 ohms -> 8 leds rouge diam 1,8mm
; 1 entree sur PORTA,0 <- Transistor 2N2222 <- capteur de proximite
; 1 entre  sur PORTA,1 libre
; 1 sortie sur PORTA,2 libre
; 1 sortie sur PORTA,3 -> DS275 -> RS232 Tx
; 1 entre  sur PORTA,4 <- DS275 <- Rs232 Rx
; "Voice Coil" Disque dur actionne/synchronise par oscilateur NE555,
; R ajustable domaine de frequence :

;---- Equivalences ---------
#define Leds		PORTB
#define Top_Synchro PORTA,0
#define Rs_Tx	    PORTA,3
#define Rs_Rx  	    PORTA,4
#define Quartz      4000000		 

;--------------------------------------------------------------------------
;DECLARATION VARIBALE
;--------------------------------------------------------------------------
        ifdef misimde
#define RAM 0x0C
cmpt1   EQU RAM		; compteur de boucles 1
varun   EQU RAM+1	; une variable
ncar    EQU RAM+2	; numero de caractere pendant l'affichage
ncol    EQU RAM+3	; numero de colone
curseur EQU RAM+4	; curseur d'ecriture (la ou le texte sera modifier)
charRS  EQU RAM+5	; charactere recu

        else
	CBLOCK 0x0C		; debut de la zone variables
        cmpt1   : 1		; compteur de boucles 1
	varun   : 1		; une variable
	ncar    : 1		; numero de caractere pendant l'affichage
	ncol    : 1		; numero de colone
	curseur : 1		; curseur d'ecriture (la ou le texte sera modifier)
	charRS  : 1		; charactere recu
	ENDC			; Fin de la zone
        endif
text equ 0x020
	org  text
      DT "1234567890123456",0 

        ifdef misimde
count1	 EQU RAM+32	;delay routines
count2	 EQU RAM+33    	;delay routines
count3 	 EQU RAM+34    	;delay routines
_RsCount  EQU RAM+35
_RsByte	  EQU RAM+36
_Cpt1	  EQU RAM+37
_Temp1	  EQU RAM+38
LastRambank0	EQU RAM+39
        else
        CBLOCK 0x32
  	count1		;delay routines
	count2      	;delay routines
	count3      	;delay routines
	_RsCount
        _RsByte
        _Cpt1
        _Temp1
        LastRambank0
	ENDC
        endif

	IF ( (LastRambank0) > 0x4F )
		ERROR   "Attention debordement zone RAM"
	ENDIF

;--------------------------------------------------------------------------
;demarage apres reset
;--------------------------------------------------------------------------
	org 0x000 				; Adresse de depart apres reset
	goto start			; tout est en bas.

;--------------------------------------------------------------------------
;interuption
;--------------------------------------------------------------------------
	org	0x04				;en cas d'interuption (inutilise)
	retfie					;on rentre

;--------------------------------------------------------------------------
; boucle principale
;--------------------------------------------------------------------------
start:
	;init ports
    bank1
	movlw		0x00		;sorties
	movwf		PORTB		;port B (8 leds)
	movlw		b'00010011'	;
	movwf		PORTA	
    clrf INTCON	
    bank0
    clrf PORTB

;init text par defaut   
    clrf _Cpt1
St1
    movf _Cpt1,w
	call Read_EE
    movwf   _RsByte
    movlw 	text    ; on pointe en debut de texte
	addwf	_Cpt1,w	; w a l'adresse du caractere courant		
	movwf	FSR		; on va chercher le caractere
    movf _RsByte,w
	movwf	INDF  
    incf _Cpt1,f
   	ANDLW	0x0FF		
	BTFSs	STATUS, Z	
    goto St1
    clrf text+16

Presentation
        goto strap1

	
	CALL Rs_CrLf
Pres1	clrf _Cpt1
	movf _Cpt1,w
	call Msg_Eeprom

Pres2
	CALL Rs_CrLf	
	movlw EE1-EE0
	MOVWF _Cpt1
	call Msg_Eeprom

strap1

   call WaitSynchro

;Test Hardware, allumage successif des 8 leds sur 10 balayages  
    movlw d'10'
    movwf _RsCount
Test_Hardware
    movlw 0x01
    movwf _Cpt1
    bcf STATUS,C
TH_1
    call WaitSynchro
    movf _Cpt1,w
    movwf PORTB
    call delay_1mS
    clrf PORTB
    call delay_1mS
    movf _Cpt1,w
    movwf PORTB
    call delay_10mS
    clrf PORTB
    rlf _Cpt1,f
    BTFSS	STATUS, C	
    goto TH_1
    decf _RsCount,f
    BTFSS	STATUS, Z
    goto Test_Hardware

;    movlw .20
;    movwf _RsCount
;M_1
;    clrf _Cpt1
;	movf _Cpt1,w
;	call Msg_Hapr
;    decfsz _RsCount,f
;    goto M_1

	movlw	d'0'
	movlw	curseur			; le curseur et sur 0


Pres3
	CALL Rs_CrLf	
	movlw EE2-EE0
	MOVWF _Cpt1
	call Msg_Eeprom


boucle ; -------------------------------------------------------------------
	call WaitSynchro 	; capteur de proximite entre en PortA,0
	movlw		d'16'
	movwf		ncar		; on passe en caractere 16 (ncar dans [1, 16] inclu
nextcar
    movlw		d'5'		;
	movwf		ncol		; on passe en colone 4 (ncol entre [1, 5] inclu
nextcol
	clrf        PCLATH			; page 0
	movlw 	text        ;-1	; on pointe en debut de texte
	addwf		ncar,w	; w a l'adresse du caractere courant		
	movwf		FSR		; on va chercher le caractere
	movf		INDF, w	; w a la valeur du caractre courant
	movwf		varun		; varun a la valeur du caractere
; bug V0.0 ci desssous!
;	movlw		0			
;	movwf		cmpt1		; cmpt1 = valeur index deplacement => page 2xx ou 3xx ?
    clrf        cmpt1
	addlw		d'205'	; si w+205>255 ; w > 50 on et on est en plage 3
	btfsc		STATUS, C	; si il y a eu depassement
	bsf		    cmpt1, 0	; on ajoute 1 a cmpt1
	bsf		    cmpt1, 1	; dans tout les cas on ajoute 2 a cmpt1
	movf		cmpt1, w	; w vaut ce qu'il y'a dans cmpt1
	movwf		PCLATH	; on va dans les 2xx ou 3xx
;------------
	rlf		    varun, f	; *2
	rlf		    varun, f	; *2
	addwf		varun, f	; +1 => on multiplie par 5 pour avoir l'adresse de la premiere colone

	movf		ncol, w		
	sublw		5		; on ajoute 5 - 'la colone courante'
	addwf		varun, w	; pour avoir la bonne colone
	btfss		cmpt1, 0	; si on est dans les 2xx, cmpt1,0=0
	call		Char_tbl2	; dans la table
	btfsc		cmpt1, 0	; si on est dans les 3xx, cmpt1,0=1
	call		Char_tbl3	; dans la table

	movwf		PORTB		; sur le port B
	call		delay_100uS 		; appeler la tempo de temp d'affichage
	decfsz	    ncol , f	; decrementer colone
	goto		nextcol
	clrf		PORTB		; RAZ leds port B
	call		delay_100uS 	; appeler la tempo de temp d'affichage 6em col
	call		delay_100uS 	; appeler la tempo de temp d'affichage 7em col
	call		delay_100uS 	; appeler la tempo de temp d'affichage 8em col 
	CALL        Rs_CrLf        ; pour debugging!
	decfsz	    ncar , f	; decrementer caractere
	goto		nextcar
    movlw       '.'
    call        Rs_Putchar
	goto		boucle	
;===================================================
;   subroutines
;===================================================
delay_RS
         MOVLW           d'32'        ;  pour 9600 bauds
         MOVWF           count1	; 
         DECFSZ          count1,F	; 1 cycle si pas de saut
         GOTO            $-1		; 2cycles
         Return			

delay_Half_RS
         MOVLW           d'16'            ;  pour 9600 bauds
         MOVWF           count1	; 
         DECFSZ          count1,F	
         GOTO            $-1	
         Return			



delay_25uS      goto $+1
                goto $+1
                movlw   0x01     
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   4
                movwf   count3
                goto    delay1
        
delay_100uS     movlw   0x01    
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   d'19'
                movwf   count3
                goto    delay1
                
delay_250uS     movlw   0x01    
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   d'50'
                movwf   count3
                goto    delay1
 
delay_1mS       movlw   0x01     
                movwf   count1   
                movlw   1
                movwf   count2
                movlw   d'200'
                movwf   count3
                goto    delay1


delay_10mS       movlw   0x01     
                movwf   count1	 
		        movlw  8 
		        movwf count2
	            movlw   d'205'
                movwf   count3
                goto    delay1
		
delay_25mS     movlw   0x01        ;24,36mS /4Mhz
                movwf   count1	   ;25,4mS /32Mhz
                movlw   d'20'
                movwf   count2
                movlw   d'128'
                movwf   count3
                goto    delay1


delay_100mS	movlw 1
		movwf count1	
		movlw d'79'
		movwf count2
		movlw 1
		movwf count3
		goto delay1
		
delay_250mS	movlw 1
		movwf count1	
		movlw d'196'
		movwf count2
		movlw 2
		movwf count3
		goto delay1
        
delay_1S      	movlw  4
                movwf   count1
                movlw  d'14'
                movwf   count2
                movlw   d'56'
                movwf   count3
                goto   delay1
                
delay_2_5s      movlw   8       
                movwf   count1
                movlw   d'161'
                movwf   count2
                movlw   d'218'
                movwf   count3
                goto   delay1
                
delay1        
                decfsz  count3,f    
                goto    $-1          
                decfsz  count2,f  
                goto    $-3           
                decfsz  count1,f      
                goto    $-5          
              
        return 
;----------------------------------
WaitSynchro 	; capteur de proximite + inversion -> entre en PortA,0
        ifdef misimde
	call delay_100mS	; pas trop pres du bord gauche!
        return
        else
W1:
	btfsc	Top_Synchro         ; etat 1 = hors zone synchro
	goto W1
W2	btfss Top_Synchro	; attente front montant ,donc mouvement de gauche vers droite
	goto W2
	call delay_10mS	; pas trop pres du bord gauche!
	return
        endif
;--------------------------------------
Read_RS
		Clrf            _RsByte
		Movlw           H'08'   	    ;byte 8 bit
		Movwf           _RsCount
Rx1 	call            delay_RS        ;bit de start
      	Bcf             STATUS,C        ;Carry=0
      	Btfsc           Rs_Rx           ;lit et test l'entree Rx
      	Bsf             STATUS,C        ;Rx =1, saute si Rx =0
      	rrf             _RsByte,f        
      	Decfsz          _RsCount,f
      	Goto            Rx1 
      	call            delay_RS      ;bit de stop
         Call            delay_RS     
      	return
;-----------------
Rs_Putchar			
	 	movwf       _Temp1
	 	Movlw           H'08'               ;correspond a un byte de 8 bits
         Movwf           _RsCount           ;place dans RsCount
         Bcf             Rs_Tx              ;bit start a 0
         Call            delay_RS           ;wait valeur 1bit 4800 Bauds
         Rrf         _Temp1,F               ;shift droite dans carry
         Btfsc           STATUS,C           ;si carry 0 alors saute
         Goto            $+3                ;carry =1
         Bcf             Rs_Tx              ;Tx dans PORTX =0
         Goto            $+2
         Bsf             Rs_Tx              ;Tx dans PORTx =1
         Call            delay_RS
         Decfsz          _RsCount,F         ;RsCount =RsCount -1
         Goto            $-8
         Bsf             Rs_Tx              ;bit de stop
         Call            delay_RS           ;byte envoye
         Call            delay_RS           ;byte envoye
  	return
;---------------
Rs_CrLf
	movlw d'13'
	call Choix_Out
	movlw d'10'
	call Choix_Out
	return

Choix_Out
    call Rs_Putchar
    return


Msg_Hapr
Car_Suiv
	movf _Cpt1,w
	call WaitSynchro 	; capteur de proximite entre en PortA,0
	;bank1			; pIC16F628 !
	MOVWF	EEADR
	bank1				; PIC16F84
	BSF 	EECON1,RD	;  bit 0
	bank0				; PIC16F84
	MOVF 	EEDATA,W
	bank0
    movwf   _RsByte
	ANDLW	0x0FF		
	BTFSS	STATUS, Z	
    goto    La_Suite
    return
La_Suite
    movlw		d'5'		;
	movwf		ncol		; on passe en colone 4 (ncol entre [1, 5] inclu
Col_Suiv
    movlw       d'32'
	subwf       _RsByte,w         ; valeur ascii -32 = offset table
	movwf		varun		; varun a la valeur du caractere

	clrf		cmpt1		; cmpt1 va nouS dire si on est en page 2xx ou 3xx
	addlw		d'205'	; si w+205>255 ; w > 50  on est en plage 3
	btfsc		STATUS, C	; si il y a eu depassement
	bsf		    cmpt1, 0	; on ajoute 1 a cmpt1
	bsf		    cmpt1, 1	; dans tout les cas on ajoute 2 a cmpt1
	movf		cmpt1, w	; w vaut ce qu'il y'a dans cmpt1
	movwf		PCLATH	; on va dans les 2xx ou 3xx
	rlf	    	varun, f	; *2
	rlf	    	varun, f	; *2
	addwf		varun, f	; +1 => on multiplie par 5 pour avoir l'adresse de la premiere colone
	movf		ncol, w		
	sublw		5		; on ajoute (5 - 'la colone courante')
	addwf		varun, w	; pour avoir la bonne colone
	btfss		cmpt1, 0	; si on est dans les 2xx, cmpt1,0=0
	call		Char_tbl2	; dans la table
	btfsc		cmpt1, 0	; si on est dans les 3xx, cmpt1,0=1
	call		Char_tbl3	; dans la table
	movwf		PORTB		; sur le port B
	call		delay_100uS 		; appeler la tempo de temp d'affichage
	clrf		PCLATH
	decfsz	    ncol , f	; decrementer colone
	goto	    Col_Suiv
	movlw		b'00000000'	; on eteind les leds
	movwf		PORTB		; sur le port B
	call		delay_100uS 	; appeler la tempo de temp d'affichage 7em col
	call		delay_100uS 		; appeler la tempo de temp d'affichage 8em col 
	incf	    _Cpt1 , f	; decrementer caractere
	goto		Car_Suiv
    return

;=================================

Msg_Eeprom
	movf _Cpt1,w
	;bank1			; pIC16F628 !
    ;bank0
	MOVWF	EEADR
	bank1				; PIC16F84
	BSF 	EECON1,RD	;  bit 0
	bank0				; PIC16F84
	MOVF 	EEDATA,W
	bank0
	incf	_Cpt1,f
	ANDLW	0x0FF		
	BTFSC	STATUS, Z	
	Return
	call Choix_Out
	goto Msg_Eeprom
	return
;-------
Read_EE	
	;bank1			; pIC16F628 !
	MOVWF	EEADR
	bank1				; PIC16F84
	BSF 	EECON1,RD	;  bit 0
	bank0				; PIC16F84
	MOVF 	EEDATA,W
	bank0
	return
;----------------------
; init de la zone libre poue eviter les pb avec ICProg 1.5d
;------------------------
Nb2raz equ 0x200-$

    org $                   ; adresse courante
     ifdef misimde 
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 
       else
        fill  (nop), Nb2raz-1  ; longueur zone vide  remplir
     endif

;-----------------------------------------------------------------------------------------
;table de caractere  5x7  car matrice 8x8 ne tiens pas dans un 16F84 ,il faut mini 16F628
;-----------------------------------------------------------------------------------------
	org 0x200
Char_tbl2
		addwf	PCL,f	; ajoute W a PCL pour aller lire au bon endroi
		dt	0x0, 0x0, 0x0, 0x0, 0x0  			;	32 -esp- 20					
		dt	0x0, 0x0, 0x4F, 0x0, 0x0 			;	33 - ! - 21
		dt	0x0, 0x7, 0x0, 0x7, 0x0 			;	34 - " - 22
		dt	0x14, 0x7F, 0x14, 0x7F, 0x14 		;	35 - # - 23
		dt	0x24, 0x2A, 0x7F, 0x2A, 0x12 		;	36 - $ - 24
		dt	0x23, 0x13, 0x8, 0x64, 0x62			;	37 - % - 25
		dt	0x36, 0x49, 0x55, 0x22, 0x50 		;	38 - & - 26
		dt	0x0, 0x5, 0x3, 0x0, 0x0 			;	39 - ' - 27
		dt	0x1C, 0x22, 0x41, 0x0, 0x0	 		;	40 - ( - 28
		dt	0x0, 0x0, 0x41, 0x22, 0x1C	 		;	41 - ) - 29
		dt	0x14, 0x8, 0x3E, 0x8, 0x14	 		;	42 - * - 2A
		dt	0x8, 0x8, 0x3E, 0x8, 0x8 			;	43 - + - 2B
		dt	0x0, 0x50, 0x30, 0x0, 0x0 			;	44 - , - 2C
		dt	0x8, 0x8, 0x8, 0x8, 0x8 			;	45 - - - 2D
		dt	0x0, 0x60, 0x60, 0x0, 0x0 			;	46 - . - 2E
		dt	0x20, 0x10, 0x8, 0x4, 0x2 			;	47 - / - 2F
		dt	0x3E, 0x51, 0x49, 0x45, 0x3E 		;	48 - 0 - 30
		dt	0x0, 0x42, 0x7F, 0x40, 0x0	 		;	49 - 1 - 31
		dt	0x42, 0x61, 0x51, 0x49, 0x46 		;	50 - 2 - 32
		dt	0x21, 0x41, 0x45, 0x4B, 0x31 		;	51 - 3 - 33
		dt	0x18, 0x14, 0x12, 0x7F, 0x10 		;	52 - 4 - 34
		dt	0x27, 0x45, 0x45, 0x45, 0x39 		;	53 - 5 - 35
		dt	0x3C, 0x4A, 0x49, 0x49, 0x30 		;	54 - 6 - 36
		dt	0x1, 0x71, 0x9, 0x5, 0x3 			;	55 - 7 - 37
		dt	0x36, 0x49, 0x49, 0x49, 0x36 		;	56 - 8 - 38
		dt	0x06, 0x49, 0x49, 0x29, 0x1E 		;	57 - 9 - 39
		dt	0x0, 0x36, 0x36, 0x0, 0x0 			;	58 - : - 3A
		dt	0x0, 0x56, 0x36, 0x0, 0x0 			;	59 - ; - 3B
		dt	0x8, 0x14, 0x22, 0x41, 0x0 			;	60 - < - 3C
		dt	0x14, 0x14, 0x14, 0x14, 0x14 		;	61 - = - 3D
		dt	0x0, 0x41, 0x22, 0x14, 0x8 			;	62 - > - 3E
		dt	0x2, 0x1, 0x51, 0x9, 0x6 			;	63 - ? - 3F
		dt	0x32, 0x49, 0x79, 0x41, 0x3E 		;	64 - @ - 40
		dt	0x7E, 0x11, 0x11, 0x11, 0x7E 			;	65 - A - 41
		dt	0x7F, 0x49, 0x49, 0x49, 0x36 			;	66 - B - 42
		dt	0x3E, 0x41, 0x41, 0x41, 0x22 			;	67 - C - 43
		dt	0x7F, 0x41, 0x41, 0x22, 0x1C 			;	68 - D - 44
		dt	0x7F, 0x49, 0x49, 0x49, 0x41 			;	69 - E - 45
		dt	0x7F, 0x9, 0x9, 0x9, 0x1 			    ;	70 - F - 46
		dt	0x3E, 0x41, 0x49, 0x49, 0x7A 			;	71 - G - 47
		dt	0x7F, 0x8, 0x8, 0x8, 0x7F 			    ;	72 - H - 48
		dt	0x0, 0x41, 0x7F, 0x41, 0x0	 	    	;	73 - I - 49
		dt	0x20, 0x40, 0x41, 0x3F, 0x1 			;	74 - J - 4A
		dt	0x7F, 0x8, 0x14, 0x22, 0x41 			;	75 - K - 4B
		dt	0x7F, 0x40, 0x40, 0x40, 0x40 			;	76 - L - 4C
		dt	0x7F, 0x2, 0xC, 0x2, 0x7F 			    ;	77 - M - 4D
		dt	0x7F, 0x4, 0x8, 0x10, 0x7F	 		    ;	78 - N - 4E
		dt	0x3E, 0x41, 0x41, 0x41, 0x3E 			;	79 - O - 4F
		dt	0x7F, 0x9, 0x9, 0x9, 0x6			    ;	80 - P - 50
		dt	0x3E, 0x41, 0x51, 0x21, 0x5E 			;	81 - Q - 51
		dt	0x7F, 0x9, 0x19, 0x29, 0x46 			;	82 - R - 52
Char_tbl1end
	org 0x300
Char_tbl3
		addwf	PCL,f	; ajoute W a PCL pour aller lire au bon endroi
		dt	0x46, 0x49, 0x49, 0x49, 0x31 			;	83 - S - 53
		dt	0x1, 0x1, 0x7F, 0x1, 0x1 			    ;	84 - T - 54
		dt	0x3F, 0x40, 0x40, 0x40, 0x3F 			;	85 - U - 55
		dt	0x1F, 0x20, 0x40, 0x20, 0x1F 			;	86 - V - 56
		dt	0x3F, 0x40, 0x38, 0x40, 0x3F 			;	87 - W - 57
		dt	0x63, 0x14, 0x8, 0x14, 0x63			    ;	88 - X - 58
		dt	0x7, 0x8, 0x70, 0x8, 0x7 			    ;	89 - Y - 59
		dt	0x61, 0x51, 0x49, 0x45, 0x43 			;	90 - Z - 5A
		dt	0x7F, 0x41, 0x41, 0x0, 0x0	 		;	91 - [ - 5B
		dt	0x2, 0x4, 0x8, 0x10, 0x20 			;	92 - \ - 5C
		dt	0x0, 0x0, 0x41, 0x41, 0x7F	 		;	93 - ] - 5D
		dt	0x4, 0x2, 0x1, 0x2, 0x4 			;	94 - ^ - 5E
		dt	0x40, 0x40, 0x40, 0x40, 0x40 		;	95 - _ - 5F
		dt	0x0, 0x1, 0x2, 0x4, 0x0 			;	96 - ` - 60
		dt	0x20, 0x54, 0x54, 0x54, 0x78		;	97 - a - 61
		dt	0x7F, 0x48, 0x44, 0x44, 0x38 		;	98 - b - 62
		dt	0x38, 0x44, 0x44, 0x44, 0x20 		;	99 - c - 63
		dt	0x38, 0x44, 0x44, 0x48, 0x7F 		;	100  d - 64
		dt	0x38, 0x54, 0x54, 0x54, 0x18 		;	101  e - 65
		dt	0x8, 0x7E, 0x9, 0x1, 0x2 			;	102  f - 66
		dt	0xC, 0x52, 0x52, 0x52, 0x3E 		;	103  g - 67
		dt	0x7F, 0x8, 0x4, 0x4, 0x78 			;	104  h - 68
		dt	0x0, 0x44, 0x7D, 0x40, 0x0 			;	105  i - 69
		dt	0x0, 0x20, 0x40, 0x44, 0x3D 		;	106  j - 6A
		dt	0x7F, 0x10, 0x28, 0x44, 0x0 		;	107  k - 6B
		dt	0x0, 0x41, 0x7F, 0x40, 0x0	 		;	108  l - 6C
		dt	0x7C, 0x4, 0x18, 0x4, 0x78 			;	109  m - 6D
		dt	0x7C, 0x8, 0x4, 0x4, 0x78 			;	110  n - 6E
		dt	0x38, 0x44, 0x44, 0x44, 0x38 		;	111  o - 6F
		dt	0x7C, 0x14, 0x14, 0x14, 0x8 		;	112  p - 70
		dt	0x8, 0x14, 0x14, 0x18, 0x7C 		;	113  q - 71
		dt	0x7C, 0x8, 0x4, 0x4, 0x8 			;	114  r - 72
		dt	0x48, 0x54, 0x54, 0x54, 0x20 		;	115  s - 73
		dt	0x4, 0x3F, 0x44, 0x40, 0x20 		;	116  t - 74
		dt	0x3C, 0x40, 0x40, 0x20, 0x7C 		;	117  u - 75
		dt	0x1C, 0x20, 0x40, 0x20, 0x1C 		;	118  v - 76
		dt	0x3C, 0x40, 0x30, 0x40, 0x3C 		;	119  w - 77
		dt	0x44, 0x28, 0x10, 0x28, 0x44 		;	120  x - 78
       	dt	0xC, 0x50, 0x50, 0x50, 0x3C 		;	121  y - 79
		dt	0x44, 0x64, 0x54, 0x4C, 0x44 		;	122  z - 7A
		dt	0x8, 0x36, 0x41, 0x0, 0x0 			;	123  { - 7B
		dt	0x0, 0x0, 0x7F, 0x0, 0x0 			;	124  | - 7C
		dt	0x0, 0x0, 0x41, 0x36, 0x8 			;	125  } - 7D
		dt	0x0, 0x8, 0x4, 0x8, 0x4				;	126  ~ - 7E		
char_tbl3_end

  
	ORG EEPROM
	;"1234567890123456"
; message taille 16 car maxi (LCD)
EE0 DT "HAPR_02.asm",0
EE1 DT "16F84_060925",0
EE2 DT "Paul Freyer",0
EE3 DT "1234567890123456",0

finEEprom	EQU $
EEpromLibre EQu 128-(finEEprom - EEPROM)


	END					; directive fin de programme
