; usage des plugins:  lCD 2x16/4 bits sur port B et CTRL sur port A  et Clavier/port B7..4
;**************************************************************
;minisimeDE179_Java_Console_mai2005
;C:\Misimde17x>rem 12 mai 2005
;C:\Misimde17x>rem sous Win XP
;C:\Misimde17x>rem miSimDE 1.79 plante en mode console
;C:\Misimde17x>rem  donc reste en 1.77
;C:\Misimde17x>rem mode editeur et sauvagrde fichier asm fonctionne OK
;C:\Misimde17x>rem test OK avec PONG.asm et plugin Television
;C:\Misimde17x>rem test OK avec LCD_13z.asm
;C:\Misimde17x>rem avec JAVA environnement: j2re-1_3_1_11-windows-i586.exe
;C:\Misimde17x>set CLASSPATH$=C:\Misimde17x
;C:\Misimde17x>java -classpath ";misimde177.jar;." misim.MiSimDE
;**********************************************************************
; TESTz_.asm 27/12/2005 - (pour tester menu clavier RS232 de DS16x_14.asm)
; usage des plugins  LCD16x2  5inter
;-------------------
; routine LCD 2lignes de 8 car  6 bits I/O : PortB 7 6 5 4 et PortA  0 1
; inclus routine delai4m.inc @4MHz
; programme simple pour decoder/ lire Telecommande Infrarouge Marantz 5200
;*******************************************************
; Quartz   = 4MHz
; Cycle    = 1/Fosc = 1uSec
;*******************************************************

        include <p16f84_.inc>
	ifdef miniSimDE
	p=16F84
	else
	ERRORLEVEL      -302
	Processor       16F84
	endif
	Radix           DEC
	EXPAND
	__CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC

;*****************************************************************************
; Equates, I/O, vars
;*****************************************************************************

OSC_FREQ        EQU     D'4000000'      ; Oscillator Frequency is 4 MHz
;	constantes a definir dans le programme principal:
; afficheur LCD en mode 4 bits
LCD_DATA_TRIS	EQU TRISB	; LCD DATA		Port B 
LCD_DATA	EQU PORTB	; LCD DATA 1,12,13,14  bits 4,5,6,7
LCD_CTRL_TRIS	EQU TRISA	; LCD CTRL 		Port A  
LCD_CTRL	EQU PORTA	; LCD CTRL 4,5,6   	bits 0,1,2
	ifdef miniSimDE
LCD_E           EQU 2		; LCD: Ligne de commande de controle de l'afficheur
LCD_RW          EQU 1		; LCD: Ligne de Lecture/Ecriture de l'afficheur
LCD_RS          EQU 0		; LCD: Ligne de selection de l'afficheur-> RA0
	else
LCD_E           EQU 1		; LCD: Ligne de commande de controle de l'afficheur
LCD_RS          EQU 0		; LCD: Ligne de selection de l'afficheur-> RA0
	endif
; PORTA bits
Capteur         EQU  0          ; RA0 
; misc.
LINE1           EQU     0x080   ; Set display to line 1 character 0
LINE2           EQU     0x0C0   ; Set display to line 2 character 0

#DEFINE	Led_Hecto       3       ; led entre RA3 et +5V 1=eteint 0=allum
#define	 Trx             PORTA,4

#define RAMstart 0x0C			; pour 16F84

	ifdef miniSimDE
        Tpd1 =  43      	; impuls pour 100 M
        Tpd2 = 434   		; impuls pour 1Km
        else
        CONSTANT Tpd1 =  43      	; impuls pour 100 M
        CONSTANT Tpd2 = 434   		; impuls pour 1Km
        ENDIF

IndexP          	EQU 	RAMstart
Cpt1            	EQU 	RAMstart+1     
count1          	EQU	RAMstart+2
count2          	EQU	RAMstart+3
count3          	EQU	RAMstart+4
LCDtmp          	EQU	RAMstart+5
LCDtmp1         	EQU	RAMstart+6
ASCII_O         	EQU   	RAMstart+7
ASCII_T         	EQU    	RAMstart+8
ASCII_H         	EQU     RAMstart+9
bdixmil         	EQU 	RAMstart+10
bmille          	EQU 	RAMstart+11
bcent			EQU 	RAMstart+12
bdix			EQU 	RAMstart+13
bun			EQU 	RAMstart+14
btmp			EQU 	RAMstart+15
COMND			EQu	RamStart+16
valx			EQU 	RAMstart+17
val1			EQU 	Ramstart+19
val2			EQu	RamStart+21    
Nt1			EQU	RamStart+23   
Nt2			EQU	RamStart+25
_RsByte                 EQU     RamStart+27
status_temp     	EQU	RamStart+28
w_temp          	EQU	RamStart+29
CptmS           	EQU	RamStart+30
Table_MAJ equ RamStart+31       ;-------------------
Seconde        	EQU	RamStart+31
Minute         	EQU	RamStart+32
Heure          	EQU	RamStart+33
Sem 	        EQU	RamStart+34
Jour 	        EQU	RamStart+35
Mois 	        EQU	RamStart+36
Annee 	        EQU	RamStart+37
                ;-----------------------------------

Drapeau         EQU 	RamStart+38
sum_cnt		equ	RamStart+39
sum_LO		equ	RamStart+40
sum_HI		equ	RamStart+41
RB_pnt		equ	RamStart+42
LastRing    	EQU	RAMstart+43
_N      	EQU	RAMstart+44
_N1             EQU     RAMStart+45
_tmpB           EQU     RAMStart+46
DELAY_W		EQU     RAMStart+47
DELAY_T		EQU     RAMStart+48
DELAY_H		EQU     RAMStart+49
DELAY_L		EQU     RAMStart+50
indice          EQU     RAMStart+51
sauve          EQU     RAMStart+52

         
LastRam         	EQU	RAMstart+54
	IF ( (LastRam) > 0x4F )
		ERROR   "Attention debordement zone RAM"
	ENDIF
;**************************************************************
; Program start
;**************************************************************
	ORG     0x00                ; RESET vector location
RESET           GOTO    DEBUT
;**************************************************************

        org 0x004		; adresse d'interruption

INTERRUPT       BCF     STATUS, RP0     ; Select bank 0
                movwf  	w_temp  	; sauver registre W
                swapf	STATUS , w	; swap status avec rsultat dans w
	        movwf	status_temp	; sauver status swapp
                btfss	INTCON,TOIF	; oui, tester si interrupt timer en cours
                call    IT_Timer
                btfss	INTCON,INTF	; oui, tester si interrupt RB0 en cours
                call    IT_RB0
                BTFSS   INTCON,RBIF     ; interupt Rbx ?
                CALL    IT_RBx
                swapf	status_temp,w	;fetch status, reswap nibbles
		movwf	STATUS		;restore status
		swapf	w_temp,f	;swap nibbles in preparation
		swapf	w_temp,w	;for the swap restoration of w
		retfie			;return from interrupt

IT_Timer       incf CptmS
                movf Cptms,W
                sublw 100
                BTFSC STATUS,Z
                goto IT_T1
                incf Seconde
                Clrf Cptms
                movf Seconde,W
                sublw 60
                BTFSC STATUS,Z
                goto IT_T2
;pour debug
        goto IT_T2
                incf Minute
                Clrf Seconde
                movf Minute,W
                sublw 60
                BTFSC STATUS,Z
                goto IT_T3
                INCF Heure
                Clrf Minute
                Goto IT_T4          
IT_T1                           
                goto $+1
                Goto $+1
IT_T2           Goto $+1
                GOTO $+1
IT_T3           Goto $+1
                GOTO $+1  
IT_T4           MOVLW 60
                MOVWF TMR0              
                BCF INTCON,TOIF ;raz flag interrupt
                return

IT_RB0	; incremente 2 compteur s
		incf	Nt1+1,F         ; incremente LSB
		BTFSC	STATUS,Z        ; si debordement MSB
		incf	Nt1,F
		incf	Nt2+1,F	        ; incremente LSB
		BTFSC	STATUS,Z	; si debordement MSB
		incf	Nt2,F
                nop
   		BCF INTCON,INTF ;raz flag interrupt
            return

IT_RBx	; lecture clavier Hexa sur port B (plugin)
                movf PORTB,W
                movwf _RsByte
                RRf _RsByte,f
                RRf _RsByte,f
                RRf _RsByte,f
                RRf _RsByte,f
   		BCF INTCON,RBIF ;raz flag interrupt
                BCF INTCON,RBIE
            return

;=============================================================================
; Table message to display: kept right up front to avoid crossing 0xff boundary
;=============================================================================

TABLE_ST      	
            ifdef miniSimDE
               ADDLW 0xFF      ;-1      car PCL increment sur instruction MOVWF !!!
            endif
            MOVWF  PCL 
MSG_S      ;     nop 	          <- autre solution rajouter un nop
	       RETLW   'V'
		RETLW   '='
		RETLW   0x00
MSG_M
            RETLW   'F'
		RETLW   '='
		RETLW   0x00
MSG_U
     		RETLW   'T'
		RETLW   '='
		RETLW   0x00
                            
MSG_N      	RETLW   'T'
		RETLW   'P'
		RETLW   '='
		RETLW   0x00

MSG_K          
            RETLW   'K'
		RETLW   '='
		RETLW   0x00
HexTable       
                DT "0123456789ABCDEF",0


 ;               RETLW '0'
 ;               RETLW '1'
 ;               RETLW '2'
 ;               RETLW '3'
 ;               RETLW '4'
 ;               RETLW '5'
 ;               RETLW '6'
 ;               RETLW '7'
 ;               RETLW '8'
 ;               RETLW '9'
 ;               RETLW 'A'
 ;               RETLW 'B'
 ;               RETLW 'C'
 ;               RETLW 'D'
 ;               RETLW 'E'
 ;               RETLW 'F'
 ;               retlw 0x00
;***************************************************************************
; Initialize processor registers
;*****************************************************************************
DEBUT                                   ; POWER_ON Reset (Beginning of program)
		CLRF    STATUS          ; Do initialization, Select bank 0
		CLRF    INTCON          ; Clear all int-flags, Disable interrupts
		CLRF    PCLATH          ; Keep in lower 2KByte
		CLRF    PORTA           ; ALL PORT outputs should output Low.
		CLRF    PORTB
                
                clrf _RsByte
               CLRF	valx
	       CLRF	valx+1
	       CLRF	val1
	       CLRF	val1+1
	       CLRF 	Nt1
	       CLRF	Nt1+1
	       CLRF 	Nt2
	       CLRF	Nt2+1

		bank1
        	MOVLW   0x00      ; RA 4-3-2-1-0 outputs
		MOVWF   PORTA
		MOVLW   0x0F      ; RB 7-6-5-4 outputs,  RB 3-2-1-0 inputs
		MOVWF   PORTB
		MOVLW	B'00000111'	;   Option register setup:
					;0 RB Pullups
                                        ;0 interrupt on rising edge RB0
					;0 TMR0 fed from internal clock
                                        ;0 incr TMR0 on rising edge RA4
					;0 Assign prescaler to TMR0
					;111 use 1:256 prescaling ratio TMR0 rate
                
		MOVWF	OPTION_REG
		bank0
            MOVLW B'00001000'  ;Intcon Register:
                               ;0 GIE Disable interrupts
                               ;0 Disable EEIE EEwrite complete interrupt
                               ;0 Disable TOIE TMR0 Oververflow Interrupt
                               ;0 Disable INTE RBO Interrupt Enable
                               ;1 Enable RBIE Port change interrupt
                               ;0 Clear TOIF interrupt flag for TMR0 overflow                                
                               ;0 Clear INTF interrupt flag bit for RB0
                               ;0 Clear RBIF interrupt flag for RBx change
           ; MoVWF INTCON
           ; MOVLW 60
           ; MOVWF TMR0
	
	CALL    LCD_Init   ; Initialize LCDisplay
		
;============================
Pres
       
	call LCD_Cls
	MOVLW	LINE1	;
	CALL	LCD_Cde	; Set to first line
Pres1
        movlw EE2-EE0
	MOVWF Cpt1
Pres3
	movf Cpt1,w
	CALL read_EE
	incf	Cpt1,f
	ANDLW	0x0FF		; test sur (W)
	BTFSC	STATUS, Z	; zero= fin de message ?
	GOTO Pres4  	
	Call LCD_Putchar
	goto Pres3
Pres4
        clrf indice
	call LCD_Clear1
    	movf indice,w
   	movWf sauve	; registre de travail
	call bcd3	; affichage valeur indice

Touche								; touche a zero
	call delay_10ms    
 	btfss   PORTB,2                
        goto    Augmentation
        btfss   PORTB,1                
        goto    Diminution        
        goto    Touche 


Augmentation
	call delay_10ms 
	btfss	PORTB,2  
	goto   Augmentation 
        incf indice,f
      	movf  indice,W		; @ modif 10/09/04

        subLw  36		; si depasse 35 => retour a 0
        btfsS  STATUS,Z
	goto  changeF
        clrf indice
        goto Touche

Diminution
	call delay_10ms 
	btfss    PORTB,1             
        goto     Diminution 
        movf indice,w
        sublw 1
        BTFSC STATUS,Z
        goto Touche                
        decf indice,f
         goto changeF
        goto Touche

changeF		
  
	call LCD_Clear1
        bank0
    	movf indice,w
   	movWf sauve	; registre de travail
	call bcd3	; affichage valeur indice

	call LCD_Clear2
        bank0
    	movf indice,w
	call Affich_Hexa	; affichage valeur indice



        goto  Touche

;=======================================================

Affich_Hexa
        movwf  btmp		; affichage octet --> Hexadecimal 2 digits ( de 00 a FF )
        swapf btmp,w
        andlw 0x0F
        addlw HexTable
        call TABLE_ST
        call LCD_Putchar
        movf btmp,w
        andlw 0x0f
        addlw HexTable
        call TABLE_ST
        call LCD_Putchar
  	return

;========================

RS_CRLF
	movf _RsByte,w	;sauve W
	movlw 13
	call RS_Putchar
	movlw 10
	call RS_Putchar
	movwf _RsByte	;restitue W
	return



Read_RS
        nop
        nop
        return

 Init_DS1307:
        nop
        nop
        return

;======================================
comp_signed16: 
	movf val1,w
	xorlw 0x80
	movwf valx
	movf val2,w
	xorlw 0x80
	subwf valx,w	; subtract val1-val2
	goto Are_they_equal
comp_unsigned_16: 
	movf val2,w
	subwf val1,w ; subtract Y-X
Are_they_equal:
	; Are they equal ?
	skpz
	goto result_comp
	; yes, they are equal -- compare lo
	movf val2+1,w
	subwf val1+1,w	; subtract Y-X
result_comp:
	; if val2=val1 then now Z=1.
	; if val1<val2 then now C=0.   
	; if val2<=val1 then now C=1.  
	return

;==============================	
AfficheSpeed
        RETURN
;============================

;===========================
AfficheMoyenne

		call LCD_Clear2
		MOVLW   LINE2
		CALL    LCD_Cde         ; Set cursor leftmost on line 2
		MOVLW   MSG_M           ; Point to Command message
		CALL    TABLE_MSG       ; Display the message
		MOVLW   LINE2+10
		CALL    LCD_Cde 
;		movf 	Moyenne,W	
                movlw 99
		movwf	val1
;		movf 	Moyenne+1,W
Affiche_u
		movwf	val1+1
		call bcd5V
	;	MOVLW   LINE2+8
	;	CALL    LCD_Cde         ; Set cursor leftmost on line 2
	;	MOVLW   MSG_U           ; Point to Command message
	;	CALL    TABLE_MSG       ; Display the message
	return
;----------------------


;**************************************************************
; Envoi de message via table de message dans la zone programme
;**************************************************************
TABLE_MSG
		MOVWF   Cpt1         ; Point to the first char. we want
LOOP_WR         
		MOVF   Cpt1,W         ; Renew the pointer
		CALL    TABLE_ST        ; Initiate table lookup
		XORLW   0x00            ; Is this the terminating char?
		BTFSC   STATUS,Z
		GOTO    END_WR
		CALL    LCD_Putchar      ; Actually put the char on display
		INCF    Cpt1,f	; Point to the next char
		GOTO    LOOP_WR         ; Do next character
END_WR
		RETURN
;=========================
; rev 26 janv 2003 lcd4c.inc
; fichiers lis:   delais_b.inc  lcd4c.h
;	routines en mode 4 Bits avec afficheur 2*16  base de HD77480
;	LCD_Init : initialisation de l'afficheur
;	LCD_Putchar : envoi un caractere ( contenu dans w ) sur l'afficheur
;	LCD_Cde  : envoi une commande ( contenue dans w)  l'afficheur
;	LCD_Cls  : efface l'afficheur
;	LCD_Clear1 : efface la premiere ligne de l'afficheur
;	LCD_Clear2 : efface la deuxieme ligne de l'afficheur
;	LCD_Home : renvoi le curseur en haut a gauche
;	LCD_Line1 : renvoi le curseur au debut de la ligne 1
;	LCD_Line2 : renvoi le curseur au debut de la ligne 2
;	pour positionner le curseur sur la ligne 1 :	movlw 0x80+offset	call LCD_Cde
;	pour positionner le curseur sur la ligne 2 : 	movlw 0xC0+offset	call LCD_Cde
;
;	variables a definir dans le programme principal:
;	LCDtmp,LCDTmp1			; LCD
;
;	constantes a definir dans le programme principal:
;	LCD_DATA	EQU PORTB	; LCD: Port ou est branche le bus de donnee ( bits 4  7 )
;	LCD_DATA_TRIS	EQU TRISB	; LCD: Port ou est branche le bus de donnee ( bits 4  7 )
;	LCD_CTRL	EQU PORTA	; LCD: Port ou est branche le bus de commande
;	LCD_CTRL_TRIS	EQU TRISA	; LCD: Port ou est branche le bus de commande
;	LCD_E		EQU 1		; LCD: Ligne de commande de controle de l'afficheur
;not used LCD_RW		EQU 1		; LCD: Ligne de Lecture/Ecriture de l'afficheur
;	LCD_RS		EQU 0		; LCD: Ligne de selection de l'afficheur
;
;	IMPORTANT : ce programme est optimis --> ne pas changer l'ordre des commandes


LCD_Cls  
	movlw	D'01'			; effacage de l'ecran
	call	LCD_Cde
	goto	delay_2_5ms

;--------------------
LCD_Clear1				; effacage de la 1ere ligne
	movlw	D'16'			
	movwf	LCDtmp1
	movlw	LINE1			; 0x80
	call	LCD_Cde
	call	delay_2_5ms
LCDc111
	movlw	' '
	call	LCD_Putchar
	decfsz	LCDtmp1,f
	goto	LCDc111
LCD_Line1
	movlw	LINE1
	call	LCD_Cde
	goto	delay_2_5ms
;--------------

LCD_Clear2				; effacage de la deuxieme ligne
	movlw	D'16'		
	movwf	LCDtmp1
	movlw	LINE2			; 0xC0
	call	LCD_Cde
	call	delay_2_5ms
LCDcl21
	movlw	' '
	call	LCD_Putchar
	decfsz LCDtmp1,f
	goto	LCDcl21
LCD_Line2
	movlw	LINE2
	call	LCD_Cde
	goto	delay_2_5ms

LCD_Home
	movlw	D'02'
	call	LCD_Cde
	goto delay_2_5ms


RS_Putchar nop

LCD_Putchar
	bank0				; rajout 7/03/03 
	movwf	LCDtmp
	call	delay_1ms
	movlw   0x0f
	andwf   LCD_DATA,F
	movf    LCDtmp,w
	andlw   0xF0
	iorwf   LCD_DATA,F
	ifdef miniSimDE
	bcf     LCD_CTRL, LCD_RW
	nop
	endif
	bsf     LCD_CTRL, LCD_RS
	nop
	bsf     LCD_CTRL, LCD_E
	call		delay_25us
	bcf     LCD_CTRL, LCD_E
	call		delay_25us
	movlw   0x0f
	andwf   LCD_DATA,F
	swapf   LCDtmp,W
	andlw   0xF0
	iorwf   LCD_DATA,F
	nop
	bsf     LCD_CTRL, LCD_E
	call		delay_25us
	bcf     LCD_CTRL, LCD_E
	call		delay_25us
	return

LCD_Init
	bcf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_RS
	nop
	ifdef miniSimDE
	bcf     LCD_CTRL, LCD_RW
	endif
	call 	delay_2_5ms
	movlw	0x0f
	andwf	LCD_DATA,F
	movlw	0x030			; Commande pour interface 4 bits
	iorwf	LCD_DATA,F
	bank1
	movlw   0x0F
	andwf   LCD_DATA_TRIS,W
	movwf   LCD_DATA_TRIS		; Port en sortie
	bank0
	bsf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_E
	call 	delay_2_5ms
	bsf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_E
	call 	delay_2_5ms		
	bsf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_E
	call 	delay_100ms		; tempo 100ms , remplace l'attente Wait_Busy de l'afficheur
	movlw   0x0f
	andwf   LCD_DATA,F
	movlw   0x020           ; Commande pour interface 4 bits
	iorwf   LCD_DATA,F
	bsf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_E
	movlw   0x028		; Envoi de la commande Fonction 4-bit , Font, Nombre de lignes
	call    LCD_Cde
	movlw   0x008		; display off
	call    LCD_Cde
	movlw   0x00C		; display on (0x00C sans curseur, 0x00E avec , 0x00F clign. )
	call    LCD_Cde
	movlw   0x006
	
LCD_Cde
	movwf   LCDtmp
	ifdef miniSimDE
	call 	delay_100ms		; tempo 100ms , remplace l'attente Wait_Busy de l'afficheur
	endif
	movlw   0x0f
	andwf   LCD_DATA,F
	movf    LCDtmp,w          
	andlw   0xF0
	iorwf   LCD_DATA,F
	ifdef miniSimDE
	bcf     LCD_CTRL,LCD_RW
	nop
	endif
	bcf     LCD_CTRL,LCD_RS
	nop
	bsf     LCD_CTRL,LCD_E
	nop
	bcf     LCD_CTRL,LCD_E
	movlw   0x0f
	andwf   LCD_DATA,F
	swapf   LCDtmp,W
	andlw   0xF0
	iorwf   LCD_DATA,F
	bsf     LCD_CTRL,LCD_E
	nop
	bcf     LCD_CTRL,LCD_E
	return
;-----------------------
;delais4M.inc pour Fquartz=4Mhz
;last update: 28 mars 2003
;count1 count2 count3  en bank0 pour delay routines
;delay_RS special pour routine d'attente bit 4800 Bauds
;delay : 5(count3-1)+1282(count2-1)+327684(count1-1)+6
;delay_25us delay_100us  delay_200us 
;delay_1ms delay2_5ms  delay_10ms delay_100ms delay_500ms
;delay_1sec delay_10sec
;---------------------
;special pour routine d'attente bit 4800 Bauds
delay_RS
	   MOVLW           67           ; .67 pour 4800 bauds
         MOVWF           count1
         DECFSZ          count1,F
         GOTO            $-1
         Return
;------------------------
delay           movlw   0x001       
                movwf   count1     
                movlw   0x001     
                movwf   count2    
                movlw   0x020       
                movwf   count3    
delay1          decfsz  count3,f    
                goto    $-1          
                decfsz  count2,f  
                goto    $-3           
                decfsz  count1,f      
                goto    $-5          
        return            
;--------------
delay_25us      movlw   0x01     
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   5
                movwf   count3
                goto    delay1
        
delay_100us     movlw   0x01    
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   20
                movwf   count3
                goto    delay1
   
        
delay_1ms       movlw   0x01       
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   200
                movwf   count3
                goto    delay1

delay_2_5ms       movlw   0x01       
                movwf   count1
                movlw   0x02
                movwf   count2
                movlw   243
                movwf   count3
                goto    delay1


delay_10ms       movlw   0x01      
                movwf   count1
                movlw   8
                movwf   count2
                movlw   205
                movwf   count3
                goto    delay1
		
delay_100ms     movlw   0x01        
                movwf   count1
                movlw   79
                movwf   count2
                movlw   0x01
                movwf   count3
                goto    delay1

delay_500ms	movlw 2
		movwf count1	
		movlw 135
		movwf count2
		movlw 106
		movwf count3
		goto delay1
        
delay_1s      	movlw   4          
                movwf   count1
                movlw   14
                movwf   count2
                movlw   56
                movwf   count3
                goto   delay1
                
delay_2_5s      movlw   8          
                movwf   count1
                movlw   161
                movwf   count2
                movlw   218
                movwf   count3
                goto   delay1

delay_10s     	movlw   31       
                movwf   count1
                movlw   133
                movwf   count2
                movlw   51
                movwf   count3
                goto   delay1
;-----------------------

; variable pour convertion binaire --> BCD 16bits
;bcent		EQU 	RAMstart+32
;bdix		EQU 	RAMstart+33
;bun		EQU 	RAMstart+34
;btmp		EQU 	RAMstart+35
;btmp1		EQU 	RAMstart+36
;val1		EQU 	RAMstart+37		; variable pour stockage valeur 16 bits
;val2		EQU 	RAMstart+39
;===============================================

bcd3	movwf  btmp		; affichage octet --> decimal 3 digits ( de 0 a 255 )
	movlw  '0'
        movwf  bcent
	movwf  bdix
bcd31	movlw  100
        subwf  btmp,w
	bnc    bcd32
	movwf  btmp
	incf   bcent,f
	goto   bcd31
bcd32   movlw  10
	subwf  btmp,w
	bnc    bcd33
	movwf  btmp
	incf   bdix,f
	goto   bcd32
bcd33	movlw  '0'
	addwf  btmp,w
	movwf  bun
	movf   bcent,w
	call   LCD_Putchar
	movf   bdix,w
	call   LCD_Putchar
	movf   bun,w
	call   LCD_Putchar
	return



; affichage octet --> decimal 5 digits , de 0 a 65535 
; avec blanc sur les chiffres non significatifs ....1   ...1
bcd5V   bCf drapeau,0
	movf	val1,w
	movwf	valx
	movf	val1+1,w
	movwf	valx+1

	swapf  val1,w	
	iorlw  0xf0
	movwf  bmille 
	addwf  bmille,f 
	addlw  0xE2 
	movwf  bcent 
	addlw  0x32 
	movwf  bun 
	movf   val1,w 
	andlw  0x0F 
	addwf  bcent,f 
	addwf  bcent,f 
	addwf  bun,f 
	addlw  0xE9 
	movwf  bdix 
	addwf  bdix,f 
	addwf  bdix,f 
	swapf  val1+1,w 
	andlw  0x0F 
	addwf  bdix,f 
	addwf  bun,f 
	rlf    bdix,f 
	rlf    bun,f 
	comf   bun,f 
	rlf    bun,f 
	movf   val1+1,w 
	andlw  0x0F 
	addwf  bun,f 
	rlf    bmille,f 
	movlw  0x07 
	movwf  bdixmil 
        movlw  0x0A
Lb1: 	addwf  bun,f 
	decf   bdix,f 
	btfss  STATUS,C
	goto   Lb1 
Lb2:	addwf  bdix,f 
	decf   bcent,f 
	btfss  STATUS,C
	goto   Lb2 
Lb3:	addwf  bcent,f 
	decf   bmille,f 
	btfss  STATUS,C
	goto   Lb3 
Lb4:	addwf  bmille,f 
        decf   bdixmil,f 
	btfss  STATUS,C
        goto   Lb4 

	movf   bdixmil,w
        BTFSC STATUS,Z
        BTFSC drapeau,0
        goto Lb40a
        movlw ' '
        goto Lb40b
Lb40a:  bsf drapeau,0
	addlw  '0'
Lb40b:  call   LCD_Putchar

	movf   bmille,w
        BTFSC STATUS,Z
        BTFSc drapeau,0
        goto Lb41a
        movlw ' '
        goto Lb41b
Lb41a:  bsf drapeau,0
	addlw  '0'
Lb41b:  call   LCD_Putchar  

	movf   bcent,w
        BTFSC STATUS,Z
        BTFSc drapeau,0
        goto Lb42a
        movlw ' '
        goto Lb42b
Lb42a:  bsf drapeau,0
	addlw  '0'
Lb42b:  call   LCD_Putchar  

	movf   bdix,w
        BTFSC STATUS,Z
        BTFSc drapeau,0
        goto Lb43a
        BTFSC drapeau,1         ; affichage ..0.0 kms
        goto Lb43a
        movlw ' '
        goto Lb43b
Lb43a:  bsf drapeau,0
	addlw  '0'
Lb43b:  call   LCD_Putchar  

        BTFSS drapeau,1         ; affichage ...0.0 kms
        goto Lb44               ; si drapeau ......X. = 1
	movlw	'.'             ; sinon ....0
	call LCD_Putchar
Lb44:	movf   bun,w
	addlw  '0'
 	call   LCD_Putchar
	movlw	' '
	call LCD_Putchar
	movf valx,w
	movwf val1
	movf valx+1,w
	movwf	val1+1
        BCF drapeau,1
	return
;-------------------
; voir 84_IRC5_.h pour environnment et variables
;*************************************************
;==================================================================
; HEX_TO_ASC .. Converts a hex digit to three ASCII characters
;               Enter with the hex digit in ASCII_O
;               Exit with Hundreds ascii digit in ASCII_H,
;               Tens ascii digit in ASCII_T,
;               and Ones ascii digit in ASCII_O.
;               The incoming byte is not preserved.
;==================================================================

HEX_TO_ASC      MOVLW   '0'             ; Preload a zero into 10's & 100's
		MOVWF   ASCII_T
		MOVWF   ASCII_H
DO_100s         MOVLW   D'100'
		SUBWF   ASCII_O,w       ; Subtract 100 to test size
		BNC     DO_10s          ; It's less than 100, so branch
		MOVWF   ASCII_O         ; It was bigger, so decrement it
		INCF    ASCII_H,f       ; Bump up the 100's digit
		GOTO    DO_100s         ; Loop again till < 100
DO_10s          MOVLW   D'10'
		SUBWF   ASCII_O,w       ; Subtract 10 to test size
		BNC     ADJUST          ; It's less than 10, so branch
		MOVWF   ASCII_O         ; It was bigger, so decrement it
		INCF    ASCII_T,f       ; Bump up the 10's digit
		GOTO    DO_10s          ; Loop again till < 10
ADJUST          MOVLW   '0'             ; The # in ASCII_O is now < 10
		ADDWF   ASCII_O,f       ; Turn it into an ASCII character
BLANK_ZEROS     MOVLW   '0'
		XORWF   ASCII_H,w       ; Is the 100's char a 0?
		BTFSS   STATUS,Z
		GOTO    HEX_DONE        ; No.
		MOVLW   ' '             ; Yes,
		MOVWF   ASCII_H         ; So replace it with a space.
		MOVLW   '0'
		XORWF   ASCII_T,w       ; Is the 10's char a 0?
		BTFSS   STATUS,Z
		GOTO    HEX_DONE        ; No.
		MOVLW   ' '             ; Yes,
		MOVWF   ASCII_T         ; So replace it with a space
HEX_DONE        RETURN

Affiche_Time
	SWAPF	Jour,W
	ANDLW	0x0F
	ADDLW	0x30
	CALL	 LCD_Putchar  
	MOVF	Jour,W
	ANDLW	0x0F
	ADDLW	0x30
	CALL	 LCD_Putchar  
	MOVLW	'/'
	CALL	 LCD_Putchar  
	SWAPF	Mois,W
	ANDLW	0x0F
	ADDLW	0x30
	CALL	 LCD_Putchar  
	MOVF	Mois,W
	ANDLW	0x0F
	ADDLW	0x30
	CALL	 LCD_Putchar  
	MOVLW	'/'
	CALL	 LCD_Putchar  
	SWAPF	Annee,W
	ANDLW	0x0F
	ADDLW	0x30
	CALL	 LCD_Putchar  
	MOVF	Annee,W
	ANDLW	0x0F
	ADDLW	0x30
	CALL	 LCD_Putchar  	
	MOVLW	' ' 
	CALL	 LCD_Putchar  	
	SWAPF	Heure,W
	ANDLW	0x0F
	ADDLW	0x30
	CALL	 LCD_Putchar  
	MOVF	Heure,W
	ANDLW	0x0F
	ADDLW	0x30
	CALL	 LCD_Putchar  
	MOVLW	'H'
	CALL	 LCD_Putchar  	
	SWAPF	Minute,W
	ANDLW	0x0F
	ADDLW	0x30
	CALL	 LCD_Putchar  
	MOVF	Minute,W
	ANDLW	0x0F
	ADDLW	0x30
	CALL	 LCD_Putchar  
	MOVLW	'M'
	CALL	 LCD_Putchar  	
	SWAPF	Seconde,W
	ANDLW	0x0F
	ADDLW	0x30
	CALL	 LCD_Putchar  
	MOVF	Seconde,W
	ANDLW	0x0F
	ADDLW	0x30
	CALL	 LCD_Putchar  
	MOVLW	'S'
	CALL	 LCD_Putchar  
	return	
;****************************************************************************		
read_EE	

	movwf   EEADR           ; defini offset addresse
	bank1			; 16F84 !!!!
	bsf     EECON1,RD       ; mode lecture
	bank0			; 16F84 !!!!
	movf    EEDATA,W       	; recupere lecture

	return



;=====================================
; delay parameter
; DELAY_H   msb
; DELAY_L   lsb
; delai cod sur 16 bits donc gamme de 1 a 65535 mS
; 
;-----------------------------------------------
Delay_
	comf        DELAY_H,f   ; 1     1
        comf        DELAY_L,f   ; 1     1
        incf        DELAY_L,f   ; 1     1
        btfsc       STATUS,Z    ; 1/2   1/2
        incf        DELAY_H,f   ; 1     1
; --------------------------------------------- = 5 always 
; inner loop for 1000 instruction cycles
; at 40MHz each instruction takes 4 clock
; 1 cycle =0,1?S 
; 10000 instruction cycles = 1ms
; -----------------------------------Cycles-----
Delay01
            movlw       D'255'      ; 1     1
            movwf       DELAY_T     ; 1     1
Delay02
        	call Gaspille_36cycles  ; 2=call + 16*goto= 32  +2=return	
 			goto $+1 			; 2
	      	decfsz      DELAY_T,f   ; 1  
            goto        Delay02     ; 2    
   			call Gaspille_36cycles
        	call Gaspille_16cycles  ;
 ; ------------------------------------- = 100001 cycles
            incf        DELAY_L,f   ; 1     1
            btfsc       STATUS,Z    ; 1/2   1/2
            incfsz      DELAY_H,f   ; 1/2   1/2
            goto        Delay01     ; 2     2 in the loop always 5
; ------------------------------------- = 5 cycles
            return                  ; 2     on exit the 5 from above + 1
; ------------------------------------- = 6 cycles
Gaspille_36cycles			;
            goto $+1		;2 
            goto $+1		;2
            goto $+1		;2
            goto $+1		;2
            goto $+1		;2
            goto $+1		;2
            goto $+1		;2
            goto $+1		;2
            goto $+1		;2
Gaspille_16cycles	 
            goto $+1		;2
            goto $+1		;2
            goto $+1		;2
            goto $+1		;2
            goto $+1		;2
            goto $+1		;2
            goto $+1		;2
		return		
;---------------------------------------
debounce_50ms
			movlw           0x00
            movwf           DELAY_H
            movlw           D'50'
            movwf           DELAY_L
            call           Delay
            return           

delay_256ms
			movlw           0x01
            movwf           DELAY_H
            movlw           0x00
            movwf           DELAY_L
            call           Delay_
            return          

        ORG 0x2FD
Freq_Table
	bSf             PCLATH,0          ; 1
        bcf             PCLATH,1          ; 1
        addwf           PCL,f             ; 1
Freq_value EQU $
       
       DT    "   1"
       DT    "   5"
       DT    "  25"
       DT    "  66"
       DT    " 100"
       DT    " 150"
       DT    " 200"
       DT    " 300"
       DT    " 400"
       DT    " 500"
       DT    " 600"
       DT    " 700"
       DT    " 800"
       DT    " 900"
       DT    "1000"
       DT    "1250"
       DT    "1500"
       DT    "1750"
       DT    "2000"
       DT    "2250"
       DT    "2500"
       DT    "2750"
       DT    "3000"
       DT    "3250"
       DT    "3500"
       DT    "3750"
       DT    "4000"
       DT    "4250"
       DT    "4500"
       DT    "4750"
       DT    "5000"
       DT    "5250"
       DT    "5500"
       DT    "5750"
       DT    "6000"
       DT    "6250"



Freq_value_fin	equ $              		

	ORG EEPROM
      ;"1234567890123456"
EE0 DT "miSimDE 1.7.7",0
EE1 DT "Testz_.  051227",0
EE2 DT "test COMF ",0

		END
#define MUTE_		13
#define OSD_		15
#define VOLUP_		16
#define VOLDOWN_	17
#define BASSUP_		22	
#define BASSDOWN_	23
#define UP_		28
#define DOWN_		29
#define TV_		63
#define RIGHT_		43
#define LEFT_		44
#define MENUON_		82	
#define MENUOFF_	83	
#define OK_		87
