;	V1.01 du 10/03/2001
;	routines de conversion binaire --> BCD pour affichage sur LCD (  utiliser avec
;	la commande LCDchar de l'include LCD4.asm
;
;	call bin8	: aff val  8 bits ( w ) en binaire --> 00000000
;	call bcd5	: aff val 16 bits (dans val1 et val2 ) en decimal 5 digits -->00000 a 65535
;	call bcd3	: aff val  8 bits ( w ) en decimal 3 digits --> 000 a 255
;	call hex8	: aff val  8 bits ( w ) en hexadecimal 2 digits --> 00 a FF
;
;	note : les valeurs 16 bits sont stockees HI-LO
;	dixmil,mille,cent,dix,un; variable pour convertion binaire --> BCD 16bits
;	bcent,bdix,bun		; variable pour convertion binaire --> BCD 16bits
;	btmp,btmp1		; variable pour convertion binaire --> BCD 16bits
;	val1:2			; variable pour stockage valeur 16 bits
;	val2:2			; variable pour stockage valeur 16 bits
;
;	les variables val1 et val2 sont  definir si elle ne sont pas dja definies par un autre module
;


bin8	movwf  btmp		; affichage octet --> binaire 8 digits
	movlw  8		; nombre de digits a afficher
	movwf  btmp1
bin81	movlw  '0'
	rlf    btmp,f
	btfsc  STATUS,C
	addlw  1
	call   LCDchar
	decf   btmp1,f
	btfsc  STATUS,Z
	return
	goto   bin81

bcd5	swapf  val1,w		; affichage octet --> decimal 5 digits ( de 0 a 65535 )
	iorlw  0xf0
	movwf  mille 
	addwf  mille,f 
	addlw  0xE2 
	movwf  cent 
	addlw  0x32 
	movwf  un 
	movf   val1,w 
	andlw  0x0F 
	addwf  cent,f 
	addwf  cent,f 
	addwf  un,f 
	addlw  0xE9 
	movwf  dix 
	addwf  dix,f 
	addwf  dix,f 
	swapf  val1+1,w 
	andlw  0x0F 
	addwf  dix,f 
	addwf  un,f 
	rlf    dix,f 
	rlf    un,f 
	comf   un,f 
	rlf    un,f 
	movf   val1+1,w 
	andlw  0x0F 
	addwf  un,f 
	rlf    mille,f 
	movlw  0x07 
	movwf  dixmil 
        movlw  0x0A
Lb1: 	addwf  un,f 
	decf   dix,f 
	btfss  STATUS,C
	goto   Lb1 
Lb2:	addwf  dix,f 
	decf   cent,f 
	btfss  STATUS,C
	goto   Lb2 
Lb3:	addwf  cent,f 
	decf   mille,f 
	btfss  STATUS,C
	goto   Lb3 
Lb4:	addwf  mille,f 
        decf   dixmil,f 
	btfss  STATUS,C
        goto   Lb4 
	movf   dixmil,w
	addlw  '0'
	call   LCDchar
	movf   mille,w
	addlw  '0'
	call   LCDchar
	movf   cent,w
	addlw  '0'
	call   LCDchar
	movf   dix,w
	addlw  '0'
	call   LCDchar
	movf   un,w
	addlw  '0'
	goto   LCDchar

bcd3	movwf  btmp		; affichage octet --> decimal 3 digits ( de 0 a 255 )
	movlw  '0'
        movwf  bcent
	movwf  bdix
bcd31	movlw  100
        subwf  btmp,w
	bnc    bcd32
	movwf  btmp
	incf   bcent,f
	goto   bcd31
bcd32   movlw  10
	subwf  btmp,w
	bnc    bcd33
	movwf  btmp
	incf   bdix,f
	goto   bcd32
bcd33	movlw  '0'
	addwf  btmp,w
	movwf  bun
	movf   bcent,w
	call   LCDchar
	movf   bdix,w
	call   LCDchar
	movf   bun,w
	goto   LCDchar

bcd2	movwf  btmp		; affichage octet --> decimal 2 digits ( de 0 a 99 )
	movlw  '0'
	movwf  bdix
bcd21   movlw  10
	subwf  btmp,w
	bnc    bcd22
	movwf  btmp
	incf   bdix,f
	goto   bcd21
bcd22	movlw  '0'
	addwf  btmp,w
	movwf  bun
	movf   bdix,w
	call   LCDchar
	movf   bun,w
	goto   LCDchar

hex8	movwf   btmp		; affichage octet --> hexadecimal 2 digits ( de 00 a FF )
        swapf   btmp,W
        andlw   0x0f
        addlw   -0x0a
        btfsc   STATUS,C
        addlw   0x07
        addlw   0x3a
	call    LCDchar		; affichage nibble poids fort
        movf    btmp,W
        andlw   0x0f
        addlw   -0x0a 
        btfsc   STATUS, C 
        addlw   0x07 
        addlw   0x3a 
	goto    LCDchar		; affichage nibble poids faible



