;8 LEDs branches sur tous les broches du portB (de RB0  RB7 ) et un boutton poussoir sur RA1 
;chaque impultion sur le BP va incrementer le registre ctr jusqu' 255 
;
list p=16f84,f=inhx8m			; Type de PIC et format de fichier
	__config	B'11111111110001'	; pas de protection du code, timer au demarrage,
						; pas de chien de garde, oscillateur a quartz.
	#include "p16f84.inc"			; Librairie pour le compilateur

ctr     equ     H'20'          
Voie    EQU     H'21'
ADCON0  EQU     H'22'
           
        bsf	    STATUS,RP0	    ; On choisi la zone memoire n1 (page1).Ca   va nous permettre de configurer le PIC, les variables etant dans cette zone memoire.
       CLRF    TRISB                 ; 
        movlw   H'02'                 ;
        movwf   TRISA               ;
        movlw   H'80'                 ;
        movwf   OPTION_REG      ;
        bcf     STATUS,RP0        ;
        clrf    ctr                      ; j'auqu' ici c'est just l'initialisation du PIC

        movlw 0
        movwf Voie
        andwf ADCONO
        movlw H'08'
        movwf Voie
        andwf ADCONO
        movlw H'28'
        movwf Voie
        andwf ADCONO

test 
        btfss   PORTA, 1          ; on test si PORTA,1 (BP )est au niveau haut   (1logique)
        goto    test

       incf     ctr,f                 ;pour la 1 fois il contient 1 (00000001)BIN
       movf     ctr,w              ; on copie ctr dans W 
       movwf    PORTB           ; on copie W dans PORTB (alors on copie ctr dans PORTB a travers W) 

attend_relach_bp
       btfsc    PORTA, 1              ;  
       goto     attend_relach_bp   ;
       goto     test                     ;ce petit boucle c'est just pour savoir que l'utulisateur a relach le BP 
       END ;
